Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/SelfTest/include/test.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/SelfTest/include/test.h	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/SelfTest/include/test.h	(revision 112)
@@ -15,4 +15,5 @@
 #include <sys/time.h>
 
+#include "Common/include/Time.h"
 #include "Behavioural/Generic/RegisterFile/include/RegisterFile.h"
 
@@ -26,33 +27,2 @@
 	      morpheo::behavioural::generic::registerfile::Parameters * param);
 
-class Time 
-{
-private : timeval time_begin;
-// private : timeval time_end;
-  
-public  : Time ()
-  {
-    gettimeofday(&time_begin     ,NULL);
-  };
-
-public  : ~Time ()
-  {
-    cout << *this;
-  };
-
-public  : friend ostream& operator<< (ostream& output_stream,
-				      const Time & x)
-  {
-    timeval time_end;
-    
-    gettimeofday(&time_end       ,NULL);
-    
-    uint32_t nb_cycles = static_cast<uint32_t>(sc_simulation_time());
-
-    double average = static_cast<double>(nb_cycles) / static_cast<double>(time_end.tv_sec-x.time_begin.tv_sec);
-    
-    output_stream << nb_cycles << "\t(" << average << " cycles / seconds )" << endl;
-
-    return output_stream;
-  }
-};
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/include/RegisterFile.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/include/RegisterFile.h	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/include/RegisterFile.h	(revision 112)
@@ -53,4 +53,5 @@
 
   public    : Component                      * _component;
+  private   : Interfaces                     * _interfaces;
 
 #ifdef SYSTEMC
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed_allocation.cpp	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed_allocation.cpp	(revision 112)
@@ -7,4 +7,5 @@
 
 #include "Behavioural/Generic/Select/Select_Priority_Fixed/include/Select_Priority_Fixed.h"
+#include "Behavioural/include/Allocation.h"
 
 namespace morpheo{
@@ -35,5 +36,5 @@
 							    ,IN  
 							    ,WEST
-							    ,"Generalist interface"
+							    ,_("Generalist interface")
 #endif
 							    );
@@ -41,23 +42,26 @@
      in_CLOCK        = interface->set_signal_clk              ("clock" ,1, CLOCK_VHDL_NO);
      in_NRESET       = interface->set_signal_in  <Tcontrol_t> ("nreset",1, RESET_VHDL_NO);
+     
+     {
+       ALLOC1_INTERFACE_BEGIN("",IN,SOUTH,_("select interface"),_param->_nb_entity);
 
-     in_VAL          = new SC_IN (Tcontrol_t)           * [_param->_nb_entity];
-    if (_param->_encoding_one_hot)
-    out_ACK          = new SC_OUT(Tcontrol_t)           * [_param->_nb_entity];
+       ALLOC1_SIGNAL_IN ( in_VAL       ,"val"       ,Tcontrol_t,1);
+       if (_param->_encoding_one_hot)
+       ALLOC1_SIGNAL_OUT(out_ACK       ,"ack"       ,Tcontrol_t,1);
 
-    for (uint32_t i=0; i<_param->_nb_entity; i++)
-      {
-	 in_VAL [i]    = interface->set_signal_in  <Tcontrol_t> ("val_"+toString(i),1);
-	if (_param->_encoding_one_hot)
-	out_ACK [i]    = interface->set_signal_out <Tcontrol_t> ("ack_"+toString(i),1);
-      }
+       ALLOC1_INTERFACE_END(_param->_nb_entity);
+     }
 
-    if (_param->_encoding_compact)
-      {
-	out_ENTITY     = interface->set_signal_out <Tentity_t > ("entity"    , _param->_size_entity);
-	out_ENTITY_ACK = interface->set_signal_out <Tcontrol_t> ("entity_ack", 1);
-      }
+     if (_param->_encoding_compact)
+     {
+       ALLOC0_INTERFACE_BEGIN("",OUT,SOUTH,_("select interface"));
 
-    // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
+       ALLOC0_SIGNAL_OUT(out_ENTITY    ,"entity"    ,Tentity_t ,_param->_size_entity);
+       ALLOC0_SIGNAL_OUT(out_ENTITY_ACK,"entity_ack",Tcontrol_t,1);
+
+       ALLOC0_INTERFACE_END();
+     }
+
+    // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
 
 #ifdef POSITION
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed_deallocation.cpp	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed_deallocation.cpp	(revision 112)
@@ -7,4 +7,5 @@
 
 #include "Behavioural/Generic/Select/Select_Priority_Fixed/include/Select_Priority_Fixed.h"
+#include "Behavioural/include/Allocation.h"
 
 namespace morpheo                    {
@@ -24,14 +25,14 @@
 	delete     in_NRESET;
 	
-	delete []  in_VAL;
-	if (_param->_encoding_one_hot)
-	  delete [] out_ACK;
-	
-	if (_param->_encoding_compact)
-	  {
-	    delete    out_ENTITY;
-	    delete    out_ENTITY_ACK;
-	  }
+        DELETE1_SIGNAL( in_VAL       ,_param->_nb_entity,1);
+        if (_param->_encoding_one_hot)
+        DELETE1_SIGNAL(out_ACK       ,_param->_nb_entity,1);
+        if (_param->_encoding_compact)
+          {
+        DELETE0_SIGNAL(out_ENTITY    ,_param->_size_entity);
+        DELETE0_SIGNAL(out_ENTITY_ACK,1);
+          }
       }
+
     // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
     
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/SelfTest/config_rotate.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/SelfTest/config_rotate.cfg	(revision 112)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/SelfTest/config_rotate.cfg	(revision 112)
@@ -0,0 +1,7 @@
+Shifter
+16	16	*4	# size_data  
+2	2	+1	# nb_port    
+0	0       +1	# shift_value
+1	2	+1	# rotate     
+0	2	+1	# direction  
+0	0	+1	# carry      
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/SelfTest/config_shift.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/SelfTest/config_shift.cfg	(revision 112)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/SelfTest/config_shift.cfg	(revision 112)
@@ -0,0 +1,7 @@
+Shifter
+16	16	*4	# size_data  
+1	2	+1	# nb_port    
+0	2	+1	# shift_value
+0	0	+1	# rotate     
+0	2	+1	# direction  
+0	2	+1	# carry      
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/SelfTest/include/test.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/SelfTest/include/test.h	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/SelfTest/include/test.h	(revision 112)
@@ -14,4 +14,5 @@
 #include <iostream>
 
+#include "Common/include/Time.h"
 #include "Behavioural/Generic/Shifter/include/Shifter.h"
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/SelfTest/src/test.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/SelfTest/src/test.cpp	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/SelfTest/src/test.cpp	(revision 112)
@@ -99,4 +99,6 @@
       (*(_Shifter->out_SHIFTER_DATA      [i])) (SHIFTER_DATA_OUT  [i]);
     }
+
+  Time * _time = new Time();
 
   /********************************************************
@@ -309,4 +311,5 @@
    * Simulation - End
    ********************************************************/
+  delete _time;
 
   cout << "<" << name << "> ............ Stop Simulation" << endl;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/include/Parameters.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/include/Parameters.h	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/include/Parameters.h	(revision 112)
@@ -29,4 +29,6 @@
   public : const uint32_t    _size_data_completion;
   public : const bool        _type_completion_bool;
+
+  public : const uint32_t    _size_shift        ;
 
   public : const bool        _internal_direction;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/src/Parameters.cpp	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/src/Parameters.cpp	(revision 112)
@@ -29,4 +29,6 @@
     _size_data_completion          ((carry != external_completion)?0:((_shift_value==0)?size_data:_shift_value)),
     _type_completion_bool          (type_completion_bool),
+
+    _size_shift                    (static_cast<uint32_t>(ceil(log2(_size_data)))),
 
     _internal_direction            ((direction == internal_right_shift)?_right :_left      ),
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/src/Shifter_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/src/Shifter_allocation.cpp	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/src/Shifter_allocation.cpp	(revision 112)
@@ -7,4 +7,5 @@
 
 #include "Behavioural/Generic/Shifter/include/Shifter.h"
+#include "Behavioural/include/Allocation.h"
 
 namespace morpheo                    {
@@ -33,5 +34,5 @@
 							      , IN  
 							      , SOUTH
-							      , "Generalist interface"
+							      , _("Generalist interface")
 #endif
 							      );
@@ -43,49 +44,31 @@
     
     {
-      // Interface "shifter"
-       in_SHIFTER_DATA      = new SC_IN (Tdata_t)      * [_param->_nb_port];
+      ALLOC1_INTERFACE_BEGIN("shifter", IN, SOUTH,_("Generalist interface"),_param->_nb_port);
+      
+      ALLOC1_SIGNAL_IN ( in_SHIFTER_DATA       ,"data"      ,Tdata_t     ,_param->_size_data);
       if (_param->_shift_value == 0)
-       in_SHIFTER_SHIFT     = new SC_IN (Tshift_t)     * [_param->_nb_port];
-      if (_param->_direction   == external_direction)
-       in_SHIFTER_DIRECTION = new SC_IN (Tdirection_t) * [_param->_nb_port];
-      if (_param->_rotate      == external_rotate)
-       in_SHIFTER_TYPE      = new SC_IN (Ttype_t)      * [_param->_nb_port];
-      if (_param->_carry       == external_carry)
-       in_SHIFTER_CARRY     = new SC_IN (Tcarry_t)     * [_param->_nb_port];
-      if (_param->_carry       == external_completion)
+      ALLOC1_SIGNAL_IN ( in_SHIFTER_SHIFT      ,"shift"     ,Tshift_t    ,_param->_size_shift);
+      if (_param->_direction == external_direction)
+      ALLOC1_SIGNAL_IN ( in_SHIFTER_DIRECTION  ,"direction" ,Tdirection_t,1);
+      if (_param->_rotate == external_rotate)
+      ALLOC1_SIGNAL_IN ( in_SHIFTER_TYPE       ,"type"      ,Ttype_t     ,1);
+      if (_param->_carry == external_carry)
+      ALLOC1_SIGNAL_IN ( in_SHIFTER_CARRY      ,"carry"     ,Tcarry_t    ,1);
+      if (_param->_carry == external_completion)
+      {
       if (_param->_type_completion_bool == true)
-       in_SHIFTER_CARRY_IN  = new SC_IN (Tcontrol_t)   * [_param->_nb_port];
+        {
+      ALLOC1_SIGNAL_IN ( in_SHIFTER_CARRY_IN   ,"carry_in"  ,Tcontrol_t  ,1);
+        }
       else
-       in_SHIFTER_COMPLETION= new SC_IN (Tdata_t)      * [_param->_nb_port];
-      out_SHIFTER_DATA      = new SC_OUT(Tdata_t)      * [_param->_nb_port];
+        {
+      ALLOC1_SIGNAL_IN ( in_SHIFTER_COMPLETION ,"completion",Tdata_t     ,_param->_size_data_completion);
+        }
+      }
+      ALLOC1_SIGNAL_OUT(out_SHIFTER_DATA       ,"data"      ,Tdata_t     ,_param->_size_data);
       
-      for (uint32_t i=0; i<_param->_nb_port; i++)
-	{
-	  Interface_fifo * interface = _interfaces->set_interface("shifter_"+toString(i)
-#ifdef POSITION
-								  , IN  
-								  , SOUTH
-								  , "Generalist interface"
-#endif
-								  );
-	 
-	   in_SHIFTER_DATA       [i] = interface->set_signal_in  <Tdata_t     > ("data"      ,_param->_size_data);
-	  if (_param->_shift_value == 0)
-	   in_SHIFTER_SHIFT      [i] = interface->set_signal_in  <Tshift_t    > ("shift"     ,static_cast<uint32_t>(ceil(log2(_param->_size_data))));
-	  if (_param->_direction == external_direction)
-	   in_SHIFTER_DIRECTION  [i] = interface->set_signal_in  <Tdirection_t> ("direction" ,1);
-	  if (_param->_rotate  == external_rotate)
-	   in_SHIFTER_TYPE       [i] = interface->set_signal_in  <Ttype_t     > ("type"      ,1);
-	  if (_param->_carry == external_carry)
-	   in_SHIFTER_CARRY      [i] = interface->set_signal_in  <Tcarry_t    > ("carry"     ,1);
-	  if (_param->_carry       == external_completion)
-	  if (_param->_type_completion_bool == true)
-	   in_SHIFTER_CARRY_IN   [i] = interface->set_signal_in  <Tcontrol_t  > ("carry_in"  ,1);
-	  else
-	   in_SHIFTER_COMPLETION [i] = interface->set_signal_in  <Tdata_t     > ("completion",_param->_size_data_completion);
-	  out_SHIFTER_DATA       [i] = interface->set_signal_out <Tdata_t     > ("data"      ,_param->_size_data);
-	}
+      ALLOC1_INTERFACE_END(_param->_nb_port);
     }
-
+    
 #ifdef POSITION
     if (usage_is_set(_usage,USE_POSITION))
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/src/Shifter_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/src/Shifter_deallocation.cpp	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/src/Shifter_deallocation.cpp	(revision 112)
@@ -7,4 +7,5 @@
 
 #include "Behavioural/Generic/Shifter/include/Shifter.h"
+#include "Behavioural/include/Allocation.h"
 
 namespace morpheo                    {
@@ -19,22 +20,28 @@
       {	
 #if (defined(STATISTICS) || defined (VHDL_TESTBENCH))
-    delete     in_CLOCK;
+        delete     in_CLOCK;
 #endif
 
-    delete []  in_SHIFTER_DATA      ;
-    if (_param->_shift_value == 0)
-    delete []  in_SHIFTER_SHIFT     ;
-    if (_param->_direction   == external_direction )
-    delete []  in_SHIFTER_DIRECTION ;
-    if (_param->_rotate      == external_rotate    )
-    delete []  in_SHIFTER_TYPE      ;
-    if (_param->_carry       == external_carry     )
-    delete []  in_SHIFTER_CARRY     ;
-    if (_param->_carry       == external_completion)
-    if (_param->_type_completion_bool == true)
-    delete []  in_SHIFTER_CARRY_IN  ;
-    else
-    delete []  in_SHIFTER_COMPLETION;
-    delete [] out_SHIFTER_DATA      ;
+        DELETE1_SIGNAL( in_SHIFTER_DATA       ,_param->_nb_port,_param->_size_data);
+        if (_param->_shift_value == 0)
+        DELETE1_SIGNAL( in_SHIFTER_SHIFT      ,_param->_nb_port,_param->_size_shift);
+        if (_param->_direction == external_direction)
+        DELETE1_SIGNAL( in_SHIFTER_DIRECTION  ,_param->_nb_port,1);
+        if (_param->_rotate == external_rotate)
+        DELETE1_SIGNAL( in_SHIFTER_TYPE       ,_param->_nb_port,1);
+        if (_param->_carry == external_carry)
+        DELETE1_SIGNAL( in_SHIFTER_CARRY      ,_param->_nb_port,1);
+        if (_param->_carry == external_completion)
+        {
+        if (_param->_type_completion_bool == true)
+          {
+        DELETE1_SIGNAL( in_SHIFTER_CARRY_IN   ,_param->_nb_port,1);
+          }
+        else
+          {
+        DELETE1_SIGNAL( in_SHIFTER_COMPLETION ,_param->_nb_port,_param->_size_data_completion);
+          }
+        }
+        DELETE1_SIGNAL(out_SHIFTER_DATA       ,_param->_nb_port,_param->_size_data);
       }
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/src/Shifter_vhdl_declaration.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/src/Shifter_vhdl_declaration.cpp	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/src/Shifter_vhdl_declaration.cpp	(revision 112)
@@ -17,5 +17,5 @@
   void Shifter::vhdl_declaration (Vhdl * & vhdl)
   {
-    uint32_t log2_size_data = static_cast<uint32_t>(ceil(log2(_param._size_data)));
+    uint32_t log2_size_data = static_cast<uint32_t>(ceil(log2(_param->_size_data)));
 
     vhdl->set_constant("cst_is_direction_left  ",1,_left      );
@@ -25,44 +25,44 @@
     vhdl->set_constant("cst_is_carry_arithmetic",1,_arithmetic);
     vhdl->set_constant("cst_is_carry_logic     ",1,_logic     );
-    vhdl->set_constant("cst_completion         ",_param._size_data,"(others => '1')");
+    vhdl->set_constant("cst_completion         ",_param->_size_data,"(others => '1')");
     
-    for (uint32_t i=0; i<_param._nb_port; i++)
+    for (uint32_t i=0; i<_param->_nb_port; i++)
       {
-	if (_param._shift_value != 0)
-	  vhdl->set_constant("shift_"+toString(i),log2_size_data, _param._shift_value);
+	if (_param->_shift_value != 0)
+	  vhdl->set_constant("shift_"+toString(i),log2_size_data, _param->_shift_value);
 	else
 	  vhdl->set_alias   ("shift_"+toString(i),std_logic(log2_size_data), "in_SHIFTER_"+toString(i)+"_SHIFT",std_logic_range(log2_size_data));
 	
-	if (_param._size_data_completion > 0)
+	if (_param->_size_data_completion > 0)
 	  {
-	    vhdl->set_signal ("shifter_completion_left_"+toString(i)+" ",_param._size_data);
-	    vhdl->set_signal ("shifter_completion_right_"+toString(i)+"",_param._size_data);
-	    vhdl->set_signal ("mask_completion_left_"+toString(i)+"    ",_param._size_data);
-	    vhdl->set_signal ("mask_completion_right_"+toString(i)+"   ",_param._size_data);
+	    vhdl->set_signal ("shifter_completion_left_"+toString(i)+" ",_param->_size_data);
+	    vhdl->set_signal ("shifter_completion_right_"+toString(i)+"",_param->_size_data);
+	    vhdl->set_signal ("mask_completion_left_"+toString(i)+"    ",_param->_size_data);
+	    vhdl->set_signal ("mask_completion_right_"+toString(i)+"   ",_param->_size_data);
 	  }
 	
 	//-----[ Shift logic Left ]--------------------------------------------
-	if (_param._have_shift_logic_left)
-	  vhdl->set_signal ("shift_logic_left_"+toString(i)+"      ",_param._size_data);
+	if (_param->_have_shift_logic_left)
+	  vhdl->set_signal ("shift_logic_left_"+toString(i)+"      ",_param->_size_data);
 	
 	//-----[ Shift logic Right ]-------------------------------------------
-	if (_param._have_shift_logic_right)
-	  vhdl->set_signal ("shift_logic_right_"+toString(i)+"     ",_param._size_data);
+	if (_param->_have_shift_logic_right)
+	  vhdl->set_signal ("shift_logic_right_"+toString(i)+"     ",_param->_size_data);
 	
 	//-----[ Shift arithmetic Left ]---------------------------------------
-	if (_param._have_shift_arithmetic_left)
-	  vhdl->set_signal ("shift_arithmetic_left_"+toString(i)+" ",_param._size_data);
+	if (_param->_have_shift_arithmetic_left)
+	  vhdl->set_signal ("shift_arithmetic_left_"+toString(i)+" ",_param->_size_data);
 	
 	//-----[ Shift arithmetic Right ]--------------------------------------
-	if (_param._have_shift_arithmetic_right)
-	  vhdl->set_signal ("shift_arithmetic_right_"+toString(i)+"",_param._size_data);
+	if (_param->_have_shift_arithmetic_right)
+	  vhdl->set_signal ("shift_arithmetic_right_"+toString(i)+"",_param->_size_data);
 	
 	//-----[ Rotate Left ]-------------------------------------------------
-	if (_param._have_rotate_left)
-	  vhdl->set_signal ("rotate_left_"+toString(i)+"           ",_param._size_data);
+	if (_param->_have_rotate_left)
+	  vhdl->set_signal ("rotate_left_"+toString(i)+"           ",_param->_size_data);
 	
 	//-----[ Rotate Right ]------------------------------------------------
-	if (_param._have_rotate_right)
-	  vhdl->set_signal ("rotate_right_"+toString(i)+"          ",_param._size_data);
+	if (_param->_have_rotate_right)
+	  vhdl->set_signal ("rotate_right_"+toString(i)+"          ",_param->_size_data);
       }
   };
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Sort/src/Sort_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Sort/src/Sort_allocation.cpp	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Sort/src/Sort_allocation.cpp	(revision 112)
@@ -53,13 +53,15 @@
     // ~~~~~[ Interface : "input" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     {
-      ALLOC1_INTERFACE("input", IN, WEST, "List of data unsort",_param->_nb_input);
+      ALLOC1_INTERFACE_BEGIN("input", IN, WEST, "List of data unsort",_param->_nb_input);
 
       ALLOC1_SIGNAL_IN(in_INPUT_VAL ,"val" , Tcontrol_t, 1);
       ALLOC1_SIGNAL_IN(in_INPUT_DATA,"data", Tdata_t   , _param->_size_data);
+
+      ALLOC1_INTERFACE_END(_param->_nb_input);
     }
 
     // ~~~~~[ Interface : "output" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     {
-      ALLOC1_INTERFACE("output",OUT, EAST, "List of data sort",_param->_nb_output);
+      ALLOC1_INTERFACE_BEGIN("output",OUT, EAST, "List of data sort",_param->_nb_output);
 
       ALLOC1_SIGNAL_OUT(out_OUTPUT_VAL  ,"val"  ,Tcontrol_t,1);
@@ -68,4 +70,6 @@
       if (_param->_have_port_data_out)
       ALLOC1_SIGNAL_OUT(out_OUTPUT_DATA ,"data" ,Tdata_t   ,_param->_size_data   );
+
+      ALLOC1_INTERFACE_END(_param->_nb_output);
     }
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Sort/src/Sort_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Sort/src/Sort_deallocation.cpp	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Sort/src/Sort_deallocation.cpp	(revision 112)
@@ -7,4 +7,5 @@
 
 #include "Behavioural/Generic/Sort/include/Sort.h"
+#include "Behavioural/include/Allocation.h"
 
 namespace morpheo                    {
@@ -25,12 +26,14 @@
 	delete     in_NRESET;
 
-	delete []  in_INPUT_VAL   ;
-	delete []  in_INPUT_DATA  ;
-	delete [] out_OUTPUT_VAL  ;
-	if (_param->_have_port_index_out)
-	delete [] out_OUTPUT_INDEX;
-	if (_param->_have_port_data_out)
-	delete [] out_OUTPUT_DATA ;
+        DELETE1_SIGNAL(in_INPUT_VAL ,_param->_nb_input, 1);
+        DELETE1_SIGNAL(in_INPUT_DATA,_param->_nb_input, _param->_size_data);
+        
+        DELETE1_SIGNAL(out_OUTPUT_VAL  ,_param->_nb_output,1);
+        if (_param->_have_port_index_out)
+        DELETE1_SIGNAL(out_OUTPUT_INDEX,_param->_nb_output,_param->_size_address);
+        if (_param->_have_port_data_out)
+        DELETE1_SIGNAL(out_OUTPUT_DATA ,_param->_nb_output,_param->_size_data   );
       }
+
     // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_allocation.cpp	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_allocation.cpp	(revision 112)
@@ -2,5 +2,5 @@
  * $Id$
  *
- * [ Description ]
+ * [ Description ]
  * 
  */
@@ -28,5 +28,5 @@
     _interfaces = entity->set_interfaces();
 
-    // ~~~~~[ Interface : "" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+    // ~~~~~[ Interface : "" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     {
       Interface_fifo * interface = _interfaces->set_interface(""
@@ -40,7 +40,7 @@
     }
 
-    // ~~~~~[ Interface : "access" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+    // ~~~~~[ Interface : "access" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     {
-      ALLOC1_INTERFACE("access",IN,WEST, "Access", _param->_nb_access);
+      ALLOC1_INTERFACE_BEGIN("access",IN,WEST, "Access", _param->_nb_access);
 
       ALLOC1_VALACK_IN ( in_ACCESS_VAL    ,VAL);
@@ -50,17 +50,19 @@
       ALLOC1_SIGNAL_IN ( in_ACCESS_ENTITY ,"entity" ,Tentity_t ,log2(_param->_nb_entity   ));
       ALLOC1_SIGNAL_OUT(out_ACCESS_VICTIM ,"victim" ,Tentity_t ,log2(_param->_nb_entity   ));
+
+      ALLOC1_INTERFACE_END(_param->_nb_access);
     }
 
     if (usage_is_set(_usage,USE_SYSTEMC))
       {
-    // -----[ Register ]---------------------------------------------------
-    reg_TABLE = new entry_t *  [_param->_size_table];
-
-    for (uint32_t i=0; i<_param->_size_table; i++)
-      reg_TABLE [i] = new entry_t (_param->_nb_entity);
-    
-    // -----[ Internal ]---------------------------------------------------
-    internal_ACCESS_ACK    = new Tcontrol_t [_param->_nb_access];
-    internal_ACCESS_VICTIM = new Tentity_t  [_param->_nb_access];
+        // -----[ Register ]---------------------------------------------------
+        reg_TABLE = new entry_t *  [_param->_size_table];
+        
+        for (uint32_t i=0; i<_param->_size_table; i++)
+          reg_TABLE [i] = new entry_t (_param->_nb_entity);
+        
+        // -----[ Internal ]---------------------------------------------------
+        ALLOC1(internal_ACCESS_ACK   ,Tcontrol_t,_param->_nb_access);
+        ALLOC1(internal_ACCESS_VICTIM,Tentity_t ,_param->_nb_access);
       }
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_deallocation.cpp	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_deallocation.cpp	(revision 112)
@@ -7,4 +7,5 @@
 
 #include "Behavioural/Generic/Victim/Victim_Pseudo_LRU/include/Victim_Pseudo_LRU.h"
+#include "Behavioural/include/Allocation.h"
 
 namespace morpheo                    {
@@ -20,19 +21,15 @@
     delete     in_CLOCK;
     delete     in_NRESET;
-    // -----[ Interface access ]-------------------------------------------
-    delete []  in_ACCESS_VAL    ;
-    delete [] out_ACCESS_ACK    ;
-    if (_param->_size_address>1)
-    delete []  in_ACCESS_ADDRESS;
-    delete []  in_ACCESS_HIT    ;
-    delete []  in_ACCESS_ENTITY ;
-    delete [] out_ACCESS_VICTIM ;
-    
-    // -----[ Register ]---------------------------------------------------
-    delete [] reg_TABLE;
 
-    // -----[ Internal ]---------------------------------------------------
-    delete [] internal_ACCESS_ACK   ;
-    delete [] internal_ACCESS_VICTIM;
+    DELETE1_SIGNAL( in_ACCESS_VAL    ,_param->_nb_access,1);
+    DELETE1_SIGNAL(out_ACCESS_ACK    ,_param->_nb_access,1);
+    DELETE1_SIGNAL( in_ACCESS_HIT    ,_param->_nb_access,1);
+    DELETE1_SIGNAL( in_ACCESS_ADDRESS,_param->_nb_access,log2(_param->_size_address));
+    DELETE1_SIGNAL( in_ACCESS_ENTITY ,_param->_nb_access,log2(_param->_nb_entity   ));
+    DELETE1_SIGNAL(out_ACCESS_VICTIM ,_param->_nb_access,log2(_param->_nb_entity   ));
+
+    DELETE1(reg_TABLE             ,_param->_size_table);
+    DELETE1(internal_ACCESS_ACK   ,_param->_nb_access);
+    DELETE1(internal_ACCESS_VICTIM,_param->_nb_access);
       }
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/src/Victim_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/src/Victim_allocation.cpp	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/src/Victim_allocation.cpp	(revision 112)
@@ -31,11 +31,11 @@
     // ~~~~~[ Interface : "" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     {
-      __ALLOC_SIGNAL(in_CLOCK ,"in_CLOCK" ,SC_CLOCK          );
-      __ALLOC_SIGNAL(in_NRESET,"in_NRESET",SC_IN (Tcontrol_t));
+      __ALLOC0_SIGNAL(in_CLOCK ,"in_CLOCK" ,SC_CLOCK          );
+      __ALLOC0_SIGNAL(in_NRESET,"in_NRESET",SC_IN (Tcontrol_t));
     }
 
     // ~~~~~[ Interface : "Access" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     {
-      __ALLOC1_INTERFACE("ACCESS",_param->_nb_access);
+      __ALLOC1_INTERFACE_BEGIN("ACCESS",_param->_nb_access);
 
       __ALLOC1_SIGNAL_IN ( in_ACCESS_VAL    ,"VAL"    ,Tcontrol_t);
@@ -46,4 +46,6 @@
       __ALLOC1_SIGNAL_IN ( in_ACCESS_ENTITY ,"ENTITY" ,Tentity_t );
       __ALLOC1_SIGNAL_OUT(out_ACCESS_VICTIM ,"VICTIM" ,Tentity_t );
+
+      __ALLOC1_INTERFACE_END(_param->_nb_access);
     }
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/src/Victim_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/src/Victim_deallocation.cpp	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/src/Victim_deallocation.cpp	(revision 112)
@@ -7,4 +7,5 @@
 
 #include "Behavioural/Generic/Victim/include/Victim.h"
+#include "Behavioural/include/Allocation.h"
 
 namespace morpheo                    {
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Makefile.Synthesis
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Makefile.Synthesis	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Makefile.Synthesis	(revision 112)
@@ -66,5 +66,6 @@
 				@\
 				$(ECHO) "Create work-space  : $@"; \
-				$(MODELTECH_VLIB) $@;
+				$(MODELTECH_VLIB) $@; \
+				$(MODELTECH_VMAP) $(XILINX_CORELIB);
 
 $(DIR_LOG)/%.sim.log		: $(DIR_VHDL)/%.vhdl $(DIR_LOG)/%.vhdl.log
